
	global	_i2c_lcd_address

	section	.data
	align	1
_i2c_lcd_address
	dc.w	64

	section	.text
	align	1

	global	_lcd_chr
_lcd_chr
	pshm	z
	ais	#-2
	tsz

	ste	0,z
	lde	_lcd_col
	aie	#1
	ste	_lcd_col
	cpe	_linekink
	bne	L2
	
	lde	#192
	ldd	_cmd_switch
	jsr	_fncall

L2	ldy	0,z
	xgdy	
	addd	#_xlat
	xgdy	
	ldab	0,y
	clra	
	tde	
	ldd	_data_switch
	jsr	_fncall

	ais	#+2
	pulm	z
	rts

	align	1

	global	_lcd_buf
_lcd_buf
	pshm	z
	ais	#-4
	tsz

	ste	0,z
	std	2,z
	beq	L4
	

L5	ldy	0,z
	ldab	0,y
	clra	
	incw	0,z
	tde	
	jsr	_lcd_chr
	decw	2,z
	bne	L5
	

L4
	ais	#+4
	pulm	z
	rts

	align	1

	global	_lcd_str
_lcd_str
	pshm	z
	ais	#-2
	tsz

	ste	0,z
	jsr	_strlen
	lde	0,z
	jsr	_lcd_buf

	ais	#+2
	pulm	z
	rts

	align	1

	global	_lcd_row
_lcd_row
	pshm	z
	tsz

	cpe	_lcd_nrows
	bls	L11
	
	lde	_lcd_nrows

L11	clrw	_lcd_col
	tey	
	xgdy	
	addd	#_rowpos-1
	xgdy	
	ldab	0,y
	clra	
	tde	
	ldd	_cmd_switch
	jsr	_fncall
	pulm	z
	rts

	align	1

	global	_lcd_justify
_lcd_justify
	pshm	z
	ais	#-2
	tsz

	ste	0,z
	bge	L13
	
	ldd	0,z
	addd	_lcd_ncols
	std	0,z

L13	tstw	0,z
	ble	L14
	
	bra	L19
	

L17	lde	#32
	jsr	_lcd_chr

L19	lde	_lcd_col
	cpe	0,z
	blo	L17
	

L14
	ais	#+2
	pulm	z
	rts

	align	1

	global	_lcd_finis
_lcd_finis
	pshm	z
	tsz

	lde	_lcd_ncols
	jsr	_lcd_justify
	pulm	z
	rts


	section	.data
_cg_Aiti
	dc.b	10
	dc.b	0
	dc.b	14
	dc.b	17
	dc.b	31
	dc.b	17
	dc.b	17
	dc.b	0
_cg_Ake
	dc.b	4
	dc.b	0
	dc.b	14
	dc.b	17
	dc.b	31
	dc.b	17
	dc.b	17
	dc.b	0
_cg_ake
	dc.b	4
	dc.b	0
	dc.b	14
	dc.b	1
	dc.b	15
	dc.b	17
	dc.b	15
	dc.b	0
_cg_padlock
	dc.b	0
	dc.b	0
	dc.b	0
	dc.b	0
	dc.b	6
	dc.b	9
	dc.b	15
	dc.b	15
_cg_flag
	dc.b	0
	dc.b	8
	dc.b	12
	dc.b	14
	dc.b	15
	dc.b	11
	dc.b	9
	dc.b	8
_cg_backtick
	dc.b	8
	dc.b	4
	dc.b	2
	dc.b	0
	dc.b	0
	dc.b	0
	dc.b	0
	dc.b	0
_cg_backslash
	dc.b	0
	dc.b	16
	dc.b	8
	dc.b	4
	dc.b	2
	dc.b	1
	dc.b	0
	dc.b	0
_cg_tilde
	dc.b	0
	dc.b	8
	dc.b	21
	dc.b	2
	dc.b	0
	dc.b	0
	dc.b	0
	dc.b	0

	section	.text
	align	1
_chargen
	pshm	z
	ais	#-4
	tsz

	ste	0,z
	ldy	#8
	sty	2,z
	lde	_cg_ix
	asle	
	asle	
	asle	
	aie	#64
	ldd	_cmd_switch
	jsr	_fncall

L22	ldy	0,z
	ldab	0,y
	clra	
	incw	0,z
	tde	
	ldd	_data_switch
	jsr	_fncall
	decw	2,z
	bne	L22
	
	lde	_cg_ix
	ted	
	aie	#1
	ste	_cg_ix

	ais	#+4
	pulm	z
	rts

	align	1

	global	_lcd_rssi
_lcd_rssi
	pshm	z
	ais	#-2
	tsz

	ste	0,z
	lde	_interface
	cpe	#2
	lbeq	L26
	
	ldx	#50
	ldd	0,z
	idiv	
	stx	0,z
	cpx	#8
	bls	L28
	
	ldd	#8
	std	0,z

L28	ldd	0,z
	cpd	_prevssi
	beq	L26
	
	ldab	_xlat+1
	clra	
	tde	
	asle	
	asle	
	asle	
	aie	#72
	ldd	0,z
	cpd	_prevssi
	bls	L30
	
	sde	
	ldd	_cmd_switch
	jsr	_fncall

L31	lde	#255
	ldd	_data_switch
	jsr	_fncall
	lde	_prevssi
	aie	#1
	ste	_prevssi
	cpe	0,z
	blo	L31
	
	bra	L26
	

L30	sube	_prevssi
	ldd	_cmd_switch
	jsr	_fncall
	clre	
	ldd	_data_switch
	jsr	_fncall
	lde	_prevssi
	aie	#-1
	ste	_prevssi

L26
	ais	#+2
	pulm	z
	rts

	align	1
_charset
	pshm	z
	tsz

	lde	#_cg_zero
	jsr	_chargen
	stab	_xlat+1
	clrw	_prevssi
	lde	#_cg_flag
	jsr	_chargen
	stab	_xlat+3
	lde	#_cg_padlock
	jsr	_chargen
	stab	_xlat+2
	lde	_chip
	cpe	#2
	lbeq	L44
	
	bhi	L47
	
	cpe	#1
	lbeq	L43
	
	bra	L42
	

L47	cpe	#3
	lbeq	L45
	

L42	ldab	#165
	stab	_xlat
	ldab	#161
	stab	_xlat+4
	ldab	#219
	stab	_xlat+5
	lde	#_cg_Aiti
	jsr	_chargen
	tde	
	stab	_xlat+196
	ldab	#225
	stab	_xlat+228
	lde	#_cg_Ake
	jsr	_chargen
	tde	
	stab	_xlat+197
	lde	#_cg_ake
	jsr	_chargen
	tde	
	stab	_xlat+229
	ldab	#239
	stab	_xlat+246
	stab	_xlat+214
	ldab	#245
	stab	_xlat+252
	stab	_xlat+220
	ldab	#223
	stab	_xlat+176
	lde	#_cg_backslash
	jsr	_chargen
	tde	
	stab	_xlat+92
	lde	#_cg_tilde
	jsr	_chargen
	tde	
	jmp	L48
	

L43	ldab	#183
	stab	_xlat
	ldab	#16
	stab	_xlat+4
	ldab	#17
	stab	_xlat+5
	jmp	L41
	

L44	ldab	#205
	stab	_xlat
	ldab	#246
	stab	_xlat+4
	ldab	#247
	stab	_xlat+5
	ldab	#142
	stab	_xlat+196
	ldab	#132
	stab	_xlat+228
	ldab	#143
	stab	_xlat+197
	ldab	#134
	stab	_xlat+229
	ldab	#153
	stab	_xlat+214
	ldab	#148
	stab	_xlat+246
	ldab	#154
	stab	_xlat+220
	ldab	#129
	stab	_xlat+252
	ldab	#178
	stab	_xlat+176
	jmp	L41
	

L45	ldab	#221
	stab	_xlat
	ldab	#16
	stab	_xlat+4
	ldab	#17
	stab	_xlat+5
	ldab	#91
	stab	_xlat+196
	ldab	#123
	stab	_xlat+228
	ldab	#174
	stab	_xlat+197
	ldab	#175
	stab	_xlat+229
	ldab	#92
	stab	_xlat+214
	ldab	#124
	stab	_xlat+246
	ldab	#94
	stab	_xlat+220
	ldab	#126
	stab	_xlat+252
	ldab	#128
	stab	_xlat+176
	ldab	#162
	stab	_xlat+36
	ldab	#160
	stab	_xlat+64
	ldab	#250
	stab	_xlat+91
	ldab	#251
	stab	_xlat+92
	ldab	#252
	stab	_xlat+93
	ldab	#29
	stab	_xlat+94
	ldab	#196
	stab	_xlat+95
	lde	#_cg_backtick
	jsr	_chargen
	tde	
	stab	_xlat+96
	ldab	#253
	stab	_xlat+123
	ldab	#254
	stab	_xlat+124
	ldab	#255
	stab	_xlat+125
	ldab	#206

L48	stab	_xlat+126

L41	ldab	_xlat+229
	stab	_xlat+134
	stab	_xlat+140
	ldab	_xlat+197
	stab	_xlat+143
	stab	_xlat+129
	ldab	_xlat+228
	stab	_xlat+132
	stab	_xlat+138
	ldab	_xlat+196
	stab	_xlat+142
	stab	_xlat+128
	ldab	_xlat+246
	stab	_xlat+148
	stab	_xlat+154
	ldab	_xlat+214
	stab	_xlat+153
	stab	_xlat+133
	pulm	z
	rts


	section	.data

LC0	dc.b	06Ch,063h,064h,020h,063h,067h,000h

	align	1	; ASM_OUTPUT_ASCII

	section	.text
	align	1

	global	_lcd_init
_lcd_init
	pshm	z
	ais	#-8
	tsz

	ste	0,z
	std	2,z
	clrw	6,z
	clrw	4,z

L53	ldy	4,z
	xgdy	
	addd	#_xlat
	xgdy	
	ldab	5,z
	stab	0,y
	incw	4,z
	ldd	4,z
	cpd	#255
	bls	L53
	
	lde	2,z
	jsr	_atow
	std	_lcd_nrows
	lde	2,z
	aie	#2
	jsr	_atow
	std	_lcd_ncols
	clrw	_lcd_col
	clrw	_linekink
	clrw	_interface
	clrw	_chip
	lde	0,z
	aie	#-1
	cpe	#5
	bhi	L55
	
	asle	
	tey	
	xgdy	
	addd	#L61
	xgdy	
	ldy	0,y
	jmp	L61t,y
L61t

	section	.data
L61
	dc.w	L56 - L61t
	dc.w	L55 - L61t
	dc.w	L57 - L61t
	dc.w	L58 - L61t
	dc.w	L60 - L61t
	dc.w	L59 - L61t

	section	.text

L56	ldd	#2
	std	_interface
	bra	L55
	

L57	ldd	#1
	bra	L89
	

L58	ldd	#2
	bra	L89
	

L59	ldd	#1
	std	_interface

L60	ldd	#3

L89	std	_chip

L55	tstw	_interface
	bne	L63
	
	lde	_i2c_lcd_address
	jsr	_i2c_probe
	tstd	
	beq	L63
	
	ldd	#3
	std	_interface

L63	lde	_interface
	cpe	#2
	beq	L67
	
	bhi	L70
	
	cpe	#1
	beq	L66
	
	bra	L65
	

L70	cpe	#3
	beq	L68
	

L65	ldd	#_lcd_cmd8
	std	6,z
	ldd	#_lcd_cmd
	std	_cmd_switch
	ldd	#_lcd_data
	bra	L90
	

L66	ldd	#_ks0073_cmd
	std	_cmd_switch
	ldd	#_ks0073_data
	bra	L90
	

L67	ldd	#_SCI_putc
	std	_cmd_switch
	bra	L90
	

L68	ldd	#_i2c_lcd_cmd8
	std	6,z
	ldd	#_i2c_lcd_cmd
	std	_cmd_switch
	ldd	#_i2c_lcd_data

L90	std	_data_switch
	lde	_interface
	cpe	#2
	bne	L71
	
	ldab	#1
	stab	_rowpos
	ldab	#2
	stab	_rowpos+1
	ldab	#3
	stab	_rowpos+2
	ldab	#4
	stab	_rowpos+3
	ldab	#16
	stab	_xlat+3
	ldab	#17
	stab	_xlat+2
	ldab	#18
	stab	_xlat+4
	ldab	#19
	stab	_xlat+5
	ldab	#46
	stab	_xlat
	jmp	L72
	

L71	lde	_chip
	cpe	#2
	beq	L75
	
	cpe	#3
	beq	L76
	
	ldab	#128
	stab	_rowpos
	ldab	#192
	stab	_rowpos+1
	ldab	#148
	stab	_rowpos+2
	ldab	#212
	bra	L91
	

L75	ldab	#128
	stab	_rowpos
	ldab	#192
	stab	_rowpos+1
	ldab	#144
	stab	_rowpos+2
	ldab	#208
	bra	L91
	

L76	ldab	#128
	stab	_rowpos
	ldab	#160
	stab	_rowpos+1
	ldab	#192
	stab	_rowpos+2
	ldab	#224

L91	stab	_rowpos+3
	lde	#15
	jsr	_delay_ms
	tstw	6,z
	beq	L78
	
	ldd	#3
	std	4,z

L79	lde	#56
	ldd	6,z
	jsr	_fncall
	lde	#5
	jsr	_delay_ms
	decw	4,z
	bne	L79
	
	lde	#40
	ldd	6,z
	jsr	_fncall
	lde	#5
	jsr	_delay_ms

L78	lde	_chip
	cpe	#3
	bne	L83
	
	lde	_lcd_nrows
	cpe	#4
	bne	L83
	
	lde	#36
	ldd	_cmd_switch
	jsr	_fncall
	lde	#9
	ldd	_cmd_switch
	jsr	_fncall
	lde	#32
	ldd	_cmd_switch
	jsr	_fncall

L83	lde	_lcd_nrows
	cpe	#1
	bne	L86
	
	lde	_lcd_ncols
	cpe	#16
	bne	L84
	

L86	lde	#40
	bra	L85
	

L84	lde	#32

L85	ldd	_cmd_switch
	jsr	_fncall
	lde	#6
	ldd	_cmd_switch
	jsr	_fncall
	lde	#12
	ldd	_cmd_switch
	jsr	_fncall
	lde	#2
	ldd	_cmd_switch
	jsr	_fncall
	lde	#5
	jsr	_delay_ms
	lde	_lcd_nrows
	cpe	#1
	bne	L87
	
	lde	_lcd_ncols
	cpe	#16
	bne	L87
	
	ldd	#9
	std	_linekink

L87	clrw	_cg_ix
	jsr	_charset
	lde	_cg_ix
	cpe	#8
	bls	L72
	
	lde	#LC0
	jsr	_doh

L72
	ais	#+8
	pulm	z
	rts


	section	.bss

	global	_lcd_nrows
_lcd_nrows
	ds.b	2

	global	_lcd_ncols
_lcd_ncols
	ds.b	2

	global	_lcd_col
_lcd_col
	ds.b	2
_interface
	ds.b	2
_chip
	ds.b	2
_linekink
	ds.b	2
_rowpos
	ds.b	4
_xlat
	ds.b	256
_cmd_switch
	ds.b	2
_data_switch
	ds.b	2
_cg_zero
	ds.b	8
_cg_ix
	ds.b	2
_prevssi
	ds.b	2


	end
