
	section	.data
	align	1
_meas
	dc.w	0
	dc.b	0
	dc.b	3
	dc.w	16383
	dc.w	0
	dc.b	0
	dc.b	5
	dc.w	4095

	section	.text
	align	1
_update
	pshm	z
	ais	#-4
	tsz

	lde	_meas
	clrw	0,z
	ldd	#50
	jsr	_DIV
	aid	#-80
	std	2,z
	lde	2,z
	jsr	_thermometer
	lde	_meas+6
	ldd	2,z
	asrd
	jsr	_SHT1x_RH_compensated
	tde	
	jsr	_hygrometer

	ais	#+4
	pulm	z
	rts


	section	.data

LC0	dc.b	063h,072h,063h,020h,072h,065h,063h,065h
	dc.b	069h,076h,065h,064h,020h,030h,078h,000h

	align	1	; ASM_OUTPUT_ASCII

LC1	dc.b	02Ch,020h,063h,061h,06Ch,063h,075h,06Ch
	dc.b	061h,074h,065h,064h,020h,030h,078h,000h

	align	1	; ASM_OUTPUT_ASCII

	section	.text
	align	1
_unload
	pshm	z
	ais	#-8
	tsz

	ste	4,z
	jsr	_SHT1x_result
	tstd	
	beq	L9
	
	ldy	4,z
	lde	4,y
	come	
	ande	0,y
	bne	L9
	
	ldy	4,z
	tstw	0,y
	bne	L5
	

L9	clrd	
	bra	L8
	

L5	ldy	#140
	sty	0,z
	ldy	4,z
	sty	2,z
	lde	#2
	clrd	
	jsr	_crc_type_1
	stab	6,z
	tstw	_debug
	beq	L6
	
	ldy	4,z
	ldab	2,y
	cmpb	6,z
	beq	L6
	
	lde	#LC0
	jsr	_print_string
	ldy	4,z
	ldab	2,y
	clra	
	tde	
	jsr	_print_word
	lde	#LC1
	jsr	_print_string
	ldab	6,z
	clra	
	tde	
	jsr	_print_word
	jsr	_eol

L6	clre	
	ldy	4,z
	ldab	2,y
	cmpb	6,z
	bne	L7
	
	lde	#1

L7	ted	

L8
	ais	#+8
	pulm	z
	rts


	section	.bss
Ltoggle.6
	ds.b	2

	section	.text
	align	1

	global	_sht1x_round
_sht1x_round
	pshm	z
	tsz

	cpe	#1
	beq	L17
	
	cpe	#2
	beq	L14
	
	jsr	_SHT1x_sync
	lde	#30
	jsr	_SHT1x_command
	tstd	
	lbeq	L10
	
	clrw	Ltoggle.6
	jmp	L10
	

L14	lde	Ltoggle.6
	asle	
	adde	Ltoggle.6
	asle	
	aie	#_meas
	jsr	_unload
	tstb	
	beq	L10
	
	lde	Ltoggle.6
	eore	#1
	ste	Ltoggle.6
	bne	L17
	
	jsr	_update

L17	lde	Ltoggle.6
	asle	
	adde	Ltoggle.6
	asle	
	tey	
	xgdy	
	addd	#_meas
	xgdy	
	ldab	3,y
	clra	
	tde	
	jsr	_SHT1x_command

L10	pulm	z
	rts



	end
